#!/usr/bin/env python

# Edit this script to add your team's code. Some functions are *required*, but you can edit most parts of the required functions,
# change or remove non-required functions, and add your own functions.

################################################################################
#
# Import libraries and functions. You can change or remove them.
#
################################################################################

from helper_code import *
import numpy as np, scipy as sp, scipy.stats, os, sys, joblib
import os, numpy as np, scipy as sp, scipy.io, scipy.io.wavfile
import csv
# from noise_reduction_function import *  # team code에 추가 해야함
from keras.layers import Activation
from keras.layers import Conv2D
from keras.layers import MaxPooling2D, Dense, Flatten,BatchNormalization, Dropout,Input, Add
from keras.layers import AveragePooling1D, GlobalAveragePooling1D,Conv1D,Multiply,Concatenate,UpSampling1D
from numpy import load
from sklearn.model_selection import train_test_split
from keras.models import Model,load_model
from keras.optimizers import adam_v2
from keras import regularizers
# import matplotlib.pyplot as plt
from numpy import savez_compressed
from keras import backend as K
from scipy import signal
# from imblearn.over_sampling import RandomOverSampler
from collections import Counter
import gc
################################################################################
#
# Required functions. Edit these functions to add your code, but do not change the arguments.
#
################################################################################

# Train your model.
def train_challenge_model(data_folder, model_folder, verbose):
    verbose=1
    
    if verbose >= 1:
        print("start")
   
    preprocessing_data(data_folder, model_folder) # 데이터 저장 과정1
    
    print(gc.collect())
    
    train_multiclass(model_folder)
    train_abnormal_normal(model_folder)   

    
   
    

# Load your trained model. This function is *required*. You should edit this function to add your code, but do *not* change the
# arguments of this function.
def load_challenge_model(model_folder, verbose):
    filename_known_unknown = os.path.join(model_folder, 'resnet50_known_unknown.h5')
    filename_abnormal_normal = os.path.join(model_folder, 'outcome_model.h5')
    # filename_unet = os.path.join(model_folder, 'u_net.h5')
    # resnet model
    input_tensor1 = Input(shape=(1, 4096, 4), dtype='float32')
    x = resnet_CNN_1(input_tensor1,19,128)
    x = resnet_CNN_1(x,9,256)
    x = resnet_CNN_1(x,5,512)
    x = resnet_CNN_1(x,3,512)
    x = resnet_CNN_3(x)
    x = Flatten()(x)
    x = Dropout(0.1)(x)
    output_tensor1 = Dense(3, activation='softmax',kernel_regularizer=regularizers.l2(0.01))(x)
    
    input_tensor = Input(shape=(1, 4096, 4), dtype='float32')
    x1 = resnet_CNN_1(input_tensor,19,128)
    x1 = resnet_CNN_1(x1,9,256)
    x1 = resnet_CNN_1(x1,5,512)
    x1 = resnet_CNN_1(x1,3,512)
    x1 = resnet_CNN_2(x1)
    x1 = Flatten()(x1)
    x1 = Dropout(0.1)(x1)
    output_tensor = Dense(1, activation='sigmoid',kernel_regularizer=regularizers.l2(0.01))(x1)       
    
    
    # unknown known classification model
    resnet50_known_unknown = Model(input_tensor1, output_tensor1)
    resnet50_known_unknown.load_weights(filename_known_unknown)
    
    resnet50_abnormal_normal = Model(input_tensor, output_tensor)
    resnet50_abnormal_normal.load_weights(filename_abnormal_normal)
    
    # model_unet = load_model(filename_unet,compile=False) 
    
    
    return [resnet50_known_unknown,resnet50_abnormal_normal]

# Run your trained model. This function is *required*. You should edit this function to add your code, but do *not* change the
# arguments of this function.
def run_challenge_model(model, data, recordings, verbose):
    classes = ['Present','Unknown','Absent']
    classes2 = ['Abnormal','Normal']
    resnet50_known_unknown=model[0]
    resnet50_abnormal_normal=model[1]
    # model_unet=model[2]   
    
    max_length=list()
    for i in range(len(recordings)):
        max_length.append(len(recordings[i]))
                   
    max_length=max(max_length)  
    
    # Load features.    
    locations = get_locations(data)

    recording_locations = ['AV', 'MV', 'PV', 'TV', 'PhC_false']
    num_recording_locations = len(recording_locations)
    recording_features = np.zeros((4, max_length), dtype=float)
    recording_featuresType = list()
    
    num_locations = len(locations)
    num_recordings = len(recordings)
    if num_locations==num_recordings:
        for i in range(num_locations):
            for j in range(num_recording_locations):
                if compare_strings(locations[i], recording_locations[j]) and np.size(recordings[i])>0:
                    
                    #filtering 과정 추가
                    recording_features[j, :] = zero_padding_test((recordings[i]),max_length)                 #AV
                    recording_featuresType.append(recording_locations[j])
    # recording_features = recording_features.flatten()

    recordings = np.vstack((recording_features)) # raw data with out filtering
    
    filtered_recordings=list() # filtered data
    for i in range(4):
        filtered_recordings.append(signal_noise_butter(recordings[i,:]))       
    filtered_recordings=np.asarray(filtered_recordings)
    
    # recordings=recordings.T
    
    pre=list()
    zero_record=list()
    zero_record_raw=list()
    for i in range(len(recordings)):
        tmp_record = segmentation_4096_test(filtered_recordings[i],max_length)  # filtered_recordings-> 전처리된 , recordings -> 전처리 안된
        tmp_record_raw = segmentation_4096_test(recordings[i],max_length)
        # tmp_predictState = np.argmax((model_unet.predict((tmp_record.reshape(max_length//4096,4096,1)+1)/2)), axis=2)
        # tmp_pre = tmp_predictState.flatten() pred = np.argmax((model.predict(test_input1)), axis=2)
        
        # pre.append(tmp_predictState)
        zero_record.append(tmp_record)
        zero_record_raw.append(tmp_record_raw)
        
    zero_record=(np.asarray(zero_record)+1)/2
    zero_record_raw=(np.asarray(zero_record_raw)+1)/2
    # pre=np.asarray(pre)
    
    zero_record=np.transpose(zero_record,[1,2,0])
    zero_record_raw=np.transpose(zero_record_raw,[1,2,0])  ####################+1/2
    # pre=np.transpose(pre,[1,2,0])
    # zero_record2=zero_record
    
    # zero transform
    # for i in range(len(pre)): #len(X1_wav)
    #     for j in range(4):
    #         for k in range(4096):
    #             if pre[i,k,j]==1 or pre[i,k,j]==3 or pre[i,k,j]==0:
    #                 zero_record[i,k,j]=0
    
            
    # filtered_recordings1=list() # filtered data
    # for i in range(4):
    #     filtered_recordings1.append(signal_noise_butter(recordings[i,:]))       
    # filtered_recordings1=np.asarray(filtered_recordings1)
    
    ## zero_record_raw, zero_record
    pre_present_unknown_absent=resnet50_known_unknown.predict(zero_record_raw.reshape(zero_record_raw.shape[0],1,zero_record_raw.shape[1],zero_record_raw.shape[2]))    
    pre_abnormal_normal=resnet50_abnormal_normal.predict((zero_record_raw.reshape(zero_record_raw.shape[0],1,zero_record_raw.shape[1],zero_record_raw.shape[2]))) 
    
    # threshold result
    # pre_abnormal_normal[pre_abnormal_normal >= 0.01]=1  ##1
    # pre_abnormal_normal[pre_abnormal_normal < 0.01]=0   ##1
    
    # Get classifier probabilities.
    probabilities_present_unknown_absent=[0,0,0]
    probabilities_abnormal=[0]
    for i in range(max_length//4096):        
        probabilities_present_unknown_absent+=pre_present_unknown_absent[i]
        probabilities_abnormal+=pre_abnormal_normal[i]
    
    probabilities_present_unknown_absent=probabilities_present_unknown_absent/(max_length//4096)
    probabilities_abnormal=probabilities_abnormal/(max_length//4096)
    
    probabilities_abnormal_normal=[probabilities_abnormal,1-probabilities_abnormal]
    
    
    # Choose label with higher probability.
    labels_present_unknown_absent = np.zeros(len(classes), dtype=np.int_)
    idx = np.argmax(probabilities_present_unknown_absent) # binary class
    # idx = (probabilities_present_unknown_absent) # catego class
    # idx = int(np.round(idx[0])) # catego class
    print(idx)
    labels_present_unknown_absent[idx] = 1
    

    labels_abnormal_normal = np.zeros(len(classes2), dtype=np.int_)
    idx = np.argmax(probabilities_abnormal_normal)
    labels_abnormal_normal[idx] = 1
    
    # Concatenate classes, labels, and probabilities.
    classes = classes + classes2
    labels = np.concatenate((labels_present_unknown_absent, labels_abnormal_normal))  ##1
    # labels = np.concatenate((labels_present_unknown_absent, [1,0]))  ##2
    probabilities = np.concatenate((probabilities_present_unknown_absent, probabilities_abnormal,1-probabilities_abnormal))  ##1
    # probabilities = np.concatenate((probabilities_present_unknown_absent, [1], [0]))  ##2

    return classes, labels, probabilities

################################################################################
#
# Optional functions. You can change or remove these functions and/or add new functions.
#
################################################################################
# def load_wav_file(filename):
#     frequency, recording = sp.io.wavfile.read(filename)
#     return recording, frequency

def zero_padding(records):
    if len(records)<=258488:
        records=np.pad(records,(0,258488-len(records)), 'constant', constant_values=(0))
    return records

def zero_padding_test(records,max_length):
    if len(records)<=max_length:
        records=np.pad(records,(0,max_length-len(records)), 'constant', constant_values=(0))
    return records


def load_tsv(data):    
    tmp=[]
    with open(data) as tsvfile:
        tsvreader = csv.reader(tsvfile, delimiter="\t")
        for line in tsvreader:
            tmp.append(line)    
    return tmp


def generate_label(tsv):
    label=np.ones([258488])
    for i in range(len(tsv)):#len(tsv)
        tmp_s=tsv[i,0]
        tmp_e=tsv[i,1]
        tmp_label=tsv[i,2]
        label[int(tmp_s):int(tmp_e)]=tmp_label*label[int(tmp_s):int(tmp_e)]
    label[int(tmp_e):]=0*label[int(tmp_e):]
    return label




def load_recordings_1(data_folder, data, get_frequencies=False): ############ 함수 이름 바꿔 주어야한다
    num_locations = get_num_locations(data)
    recording_information = data.split('\n')[1:num_locations+1]

    recordings = list()
    frequencies = list()
    for i in range(4): #num_locations
        if (num_locations<4)&(i==num_locations):
            break
        entries = recording_information[i].split(' ')
        recording_file = entries[2]
        filename = os.path.join(data_folder, recording_file)
        recording, frequency = load_wav_file(filename)
        
        recording=zero_padding(recording) # zero padding
        
        recordings.append(recording)
        frequencies.append(frequency)
        

    if get_frequencies:
        return recordings, frequencies
    else:
        return recordings



def load_recordings_label(data_folder, data, get_frequencies=False):
    num_locations = get_num_locations(data)
    recording_information = data.split('\n')[1:num_locations+1]

    recordings = list()

    for i in range(4): #num_locations
        if (num_locations<4)&(i==num_locations):
            break
        entries = recording_information[i].split(' ')
        recording_file = entries[3]
        filename = os.path.join(data_folder, recording_file)
        
        label = np.asarray(load_tsv(filename),dtype=float)

        label[:,0:2]=np.round((label[:,0:2])*4000)
        
        label=generate_label(label)      

        recordings.append(label)

    return recordings




def get_features(data, recordings):
    # Extract the age group and replace with the (approximate) number of months for the middle of the age group.
   

    # Extract recording locations and data. Identify when a location is present, and compute the mean, variance, and skewness of
    # each recording. If there are multiple recordings for one location, then extract features from the last recording.
    locations = get_locations(data)

    recording_locations = ['AV', 'MV', 'PV', 'TV', 'PhC_false']
    num_recording_locations = len(recording_locations)
    recording_features = np.zeros((4, 258488), dtype=float)
    recording_featuresType = list()
    
    num_locations = len(locations)
    num_recordings = len(recordings)
    if num_locations==num_recordings:
        for i in range(num_locations):
            for j in range(num_recording_locations):
                if compare_strings(locations[i], recording_locations[j]) and np.size(recordings[i])>0:
                    
                    #filtering 과정 추가
                    recording_features[j, :] = recordings[i]                    #AV
                    recording_featuresType.append(recording_locations[j])
    # recording_features = recording_features.flatten()

    features = np.vstack((recording_features))

    return np.asarray(features, dtype=np.float32), recording_featuresType


def get_wav_state_labels(num_patient_files,patient_files,data_folder,num_classes,classes,num_classes2,classes2,verbose=1):
    features_state = list()
    features_wav = list()
    labels = list()
    all_recordings = list()
    recording_featuresType = list()
    ab_norm = list()
    
    for i in range(num_patient_files):  #for i in range(num_patient_files)  data=current_patient_data  recordings=current_recordings for i in range(164,165) 
        if verbose >= 2:
            print('    {}/{}...'.format(i+1, num_patient_files))
    
        # Load the current patient data and recordings.
        current_patient_data = load_patient_data(patient_files[i])
        
        current_recordings = load_recordings_1(data_folder, current_patient_data)
        current_State = load_recordings_label(data_folder, current_patient_data)
    
        # check all raw recordings
        all_recordings.append(np.asarray(current_State))
        all_recordings.append(np.asarray(current_recordings))
        # Extract features.
        current_features_state, Tmp_recording_featuresType = get_features(current_patient_data, current_State)
        current_features, Tmp_recording_featuresType = get_features(current_patient_data, current_recordings)
        
        features_wav.append(current_features)    
        features_state.append(current_features_state)
        recording_featuresType.append(Tmp_recording_featuresType)
        # Extract labels and use one-hot encoding.
        current_labels = np.zeros(num_classes, dtype=int)
        current_labels2 = np.zeros(num_classes2, dtype=int)
        
        label = get_murmur(current_patient_data)
        label2 = get_outcome(current_patient_data)
        
        if label in classes:
            j = classes.index(label)
            current_labels[j] = 1
        labels.append(current_labels)   
        
        if label2 in classes2:
            j1 = classes2.index(label2)
            current_labels2[j1] = 1
        ab_norm.append(current_labels2)
    
    # features_wav = np.asarray(features_wav)          # PCG wave
    # features_state = np.asarray(features_state)      # S1 Sys S2 Dia
    # labels = np.vstack(labels)                       # Prsent Unknown Absent
    return np.asarray(features_wav), np.asarray(features_state), np.vstack(labels), np.vstack(ab_norm) 


# def oversample_data(X1,X2):
#     cnt=list()
#     y_traino1=np.argmax(X2, axis = 1)
#     counter = Counter(y_traino1)
#     for k,v in counter.items():
#         cnt.append(v)

#     strategy = {0:int(cnt[1])*3, 1:int(cnt[2])*10, 2:int(cnt[0])}
#     oversample = RandomOverSampler(sampling_strategy=strategy)
#     x_train1, y_train1 = oversample.fit_resample(X1[:,:,0,0], X2)
    
#     return X1[oversample.sample_indices_], X2[oversample.sample_indices_]


def segmentation_4096(features_wav,features_state,labels,labels2):
    X1_wav=features_wav/32768  # [-1 1] normalize
    X1_state=features_state
    X1_label=labels
    X1_ab_norm=labels2
    X1_state=np.transpose(X1_state,[0,2,1])
    X1_wav=np.transpose(X1_wav,[0,2,1])
    window_shift=4096
    
    # patient_ID=list()
    wav_4096=list()
    label_4096=list()
    seg_4096=list()
    ab_norm_4096=list()
    
    for i in range(len(X1_state)):    #942 ############################################
        for j in range(63):  #63 120 250 천단위 여서
            if (np.sum(X1_state[i,j*window_shift:(j)*window_shift+4096,:])==0):
                continue
            tmp_wav=X1_wav[i,j*window_shift:(j)*window_shift+4096,:]
            tmp_seg=X1_state[i,j*window_shift:(j)*window_shift+4096,:]
            tmp_label=X1_label[i,:]
            tmp_ab_norm=X1_ab_norm[i,:]
            
            # patient_ID.append(i)
            wav_4096.append(tmp_wav)
            seg_4096.append(tmp_seg)
            label_4096.append(tmp_label)
            ab_norm_4096.append(tmp_ab_norm)
    
    # wav_4096=np.asarray(wav_4096,dtype=float)
    # seg_4096=np.asarray(seg_4096,dtype=int)
    # label_4096=np.asarray(label_4096,dtype=int)
    # ab_norm_4096=np.asarray(ab_norm_4096,dtype=int)
    return np.asarray(wav_4096,dtype=float),np.asarray(seg_4096,dtype=int),np.asarray(label_4096,dtype=int),np.asarray(ab_norm_4096,dtype=int)


def segmentation_4096_test(features_wav,max_length):
    X1_wav=features_wav/32768  # [-1 1] normalize
    # patient_ID=list()
    wav_4096=list()
    for j in range(max_length//4096):
        tmp_wav=X1_wav[(j)*4096:4096*(j+1)]
        wav_4096.append(tmp_wav)

    wav_4096=np.asarray(wav_4096,dtype=float)
    return wav_4096



# dataset generation
def data_generation(X1,X2):
    X1=X1.reshape(X1.shape[0],1,4096,4)
    label_all=X2
    
    # present absent label
    unkown_label=np.where(label_all[:,1]!=1)
    present_absent_label=label_all[unkown_label[0],:]
    present_absent_label=present_absent_label[:,[0,2]]
    present_absent_label=present_absent_label[:,0]
    present_absent_wav=X1[unkown_label[0],:,:,:]
    
    # change label known = present, absent // unknown = unknown
    tmp_label=X2[:,0:2]
    for i in range(X1.shape[0]):
        if X2[i,2]==1:
            tmp_label[i,0]=1
            
    known_unknown_label=tmp_label[:,0]
    
    return present_absent_wav,present_absent_label.reshape(present_absent_label.shape[0],1),known_unknown_label

#############################

# classification model

#############################

def resnet_CNN_1(x,k,Ch):
    y = Conv2D(Ch, kernel_size=(1, 1), strides=(1, 1), padding='same')(x)
    y = MaxPooling2D(pool_size=(1, 2), padding='same')(y)
    shortcut = y

    for i in range(3):
        if (i == 0):
            x = BatchNormalization(axis=3)(x)
            x = Activation('relu')(x)
            x = Conv2D(Ch, kernel_size=(1, k), strides=(1, 1), padding='same')(x)

            x = BatchNormalization(axis=3)(x)
            x = Activation('relu')(x)
            x = Conv2D(Ch, kernel_size=(1, k), strides=(1, 2), padding='same')(x)

            x = Add()([x, shortcut])
            x = Activation('relu')(x)
            x = Dropout(0.1)(x)

        elif (i == 1):
            y = Conv2D(Ch, kernel_size=(1, 1), strides=(1, 1), padding='same')(x)
            y = MaxPooling2D(pool_size=(1, 2), padding='same')(y)
            shortcut = y

            x = BatchNormalization(axis=3)(x)
            x = Activation('relu')(x)
            x = Conv2D(Ch, kernel_size=(1, k), strides=(1, 1), padding='same')(x)

            x = BatchNormalization(axis=3)(x)
            x = Activation('relu')(x)
            x = Conv2D(Ch, kernel_size=(1, k), strides=(1, 2), padding='same')(x)

            x = Add()([x, shortcut])
            x = Activation('relu')(x)
            x = Dropout(0.1)(x)


        else:
            x = Dropout(0.1)(x)

    return x

def resnet_CNN_2(x):
    x = Conv2D(256, kernel_size=(1, 8), strides=(1, 1), padding='same')(x)
    x = BatchNormalization(axis=3)(x)
    x = Activation('relu')(x)
    x = Dropout(0.1)(x)

    return x


def resnet_CNN_3(x):
    x = Conv2D(512, kernel_size=(1, 8), strides=(1, 1), padding='same')(x)
    x = BatchNormalization(axis=3)(x)
    x = Activation('relu')(x)
    x = Dropout(0.1)(x)

    return x
#############################

# U-net segmentation model

#############################
# data generation
def u_net_trainsetGen(data_folder):
    patient_files = find_patient_files_1(data_folder)
    patient_files_wav = find_patient_files_wav_1(data_folder)
    

    print('Finding label_data files...')
    label_data=list()
    for i in range(len(patient_files)): #len(patient_files)
        current_label = np.asarray(load_tsv(patient_files[i]),dtype=float)
        current_label[:,0:2]=np.round((current_label[:,0:2])*4000)
        G_label=generate_label(current_label)
        label_data.append(G_label)
    
    label_data=np.asarray(label_data)
    
    
    print('Finding wav_data files...')
    wav_data=list()
    for i in range(len(patient_files_wav)): #len(patient_files)
        tmp_wav,a = load_wav_file(patient_files_wav[i])
        tmp_wav=zero_padding(tmp_wav) # zero padding
        tmp_wav=np.asarray(tmp_wav,dtype=float)
        wav_data.append(tmp_wav)
    
    wav_data=np.asarray(wav_data)
    
    X1= wav_data/32768


    wav_4096=list()
    label_4096=list()
    for i in range(len(label_data)):    #3163 63
        for j in range(63):
            if (np.mean(label_data[i][(j)*4096:4096*(j+1)])<1.5):
                continue
            tmp_wav=X1[i][(j)*4096:4096*(j+1)]
            tmp_label=label_data[i][(j)*4096:4096*(j+1)]
            wav_4096.append(tmp_wav)
            label_4096.append(tmp_label)

    wav_4096=np.asarray(wav_4096,dtype=float)
    label_4096=np.asarray(label_4096,dtype=int)
    
    filename3='unetTrainset.npz'
    savez_compressed(filename3, wav_4096,label_4096)
    print('unet Train set save done...')

def find_patient_files_1(data_folder):
    # Find patient files.
    filenames = list()
    for f in sorted(os.listdir(data_folder)):
        root, extension = os.path.splitext(f)
        if not root.startswith('.') and extension=='.tsv':
            filename = os.path.join(data_folder, f)
            filenames.append(filename)

    # To help with debugging, sort numerically if the filenames are integers.
    roots = [os.path.split(filename)[1][:-4] for filename in filenames]
    if all(is_integer(root) for root in roots):
        filenames = sorted(filenames, key=lambda filename: int(os.path.split(filename)[1][:-4]))

    return filenames

def find_patient_files_wav_1(data_folder):
    # Find patient files.
    filenames = list()
    for f in sorted(os.listdir(data_folder)):
        root, extension = os.path.splitext(f)
        if not root.startswith('.') and extension=='.wav':
            filename = os.path.join(data_folder, f)
            filenames.append(filename)

    # To help with debugging, sort numerically if the filenames are integers.
    roots = [os.path.split(filename)[1][:-4] for filename in filenames]
    if all(is_integer(root) for root in roots):
        filenames = sorted(filenames, key=lambda filename: int(os.path.split(filename)[1][:-4]))

    return filenames


##########################

# load and prepare training
def load_real_samples(filename):
	# load compressed arrays
    data = load(filename)
	# unpack arrays
    X1, X2 = data['arr_0'], data['arr_1'] 
    axis1=X1.shape[0]
    axis2=X1.shape[1]
    X1=X1.reshape(axis1,axis2,1)
    # X2=preprocessing.minmax_scale(X2)
    X2=X2.reshape(axis1,axis2,1)
    
    return (X1+1)/2, X2


def label_encoding(data):
    tmp=np.zeros([data.shape[0],data.shape[1],5])
    label_0=np.array([1, 0, 0, 0, 0])
    label_1=np.array([0, 1, 0, 0, 0])
    label_2=np.array([0, 0, 1, 0, 0])
    label_3=np.array([0, 0, 0, 1, 0])
    label_4=np.array([0, 0, 0, 0, 1])
    for i in range(len(data)):
        for j in range(4096):
            if(data[i,j,0]==0): tmp[i,j,:]=label_0
            if(data[i,j,0]==1): tmp[i,j,:]=label_1
            if(data[i,j,0]==2): tmp[i,j,:]=label_2
            if(data[i,j,0]==3): tmp[i,j,:]=label_3
            if(data[i,j,0]==4): tmp[i,j,:]=label_4
            
    return tmp
            

def cbr(x, out_layer, kernel, stride, dilation):
    x = Conv1D(out_layer, kernel_size=kernel, dilation_rate=dilation, strides=stride, padding="same")(x)
    x = BatchNormalization()(x)
    x = Activation("relu")(x)
    return x

def se_block(x_in, layer_n):
    x = GlobalAveragePooling1D()(x_in)
    x = Dense(layer_n//8, activation="relu")(x)
    x = Dense(layer_n, activation="relu")(x)
    x_out=Multiply()([x_in, x])
    return x_out

def resblock(x_in, layer_n, kernel, dilation, use_se=True):
    x = cbr(x_in, layer_n, kernel, 1, dilation)
    x = cbr(x, layer_n, kernel, 1, dilation)
    if use_se:
        x = se_block(x, layer_n)
    x = Add()([x_in, x])
    return x  

def Unet(input_shape=(None,1)):
    layer_n = 128
    kernel_size = 4
    depth = 2

    input_layer = Input(input_shape)    
    input_layer_1 = AveragePooling1D(4)(input_layer)
    input_layer_2 = AveragePooling1D(16)(input_layer)
    
    ########## Encoder
    x = cbr(input_layer, layer_n, kernel_size, 1, 1)#1000
    for i in range(depth):
        x = resblock(x, layer_n, kernel_size, 1)
    out_0 = x

    x = cbr(x, layer_n*2, kernel_size, 4, 1)
    for i in range(depth):
        x = resblock(x, layer_n*2, kernel_size, 1)
    out_1 = x

    x = Concatenate()([x, input_layer_1])    
    x = cbr(x, layer_n*3, kernel_size, 4, 1)
    for i in range(depth):
        x = resblock(x, layer_n*3, kernel_size, 1)
    out_2 = x

    x = Concatenate()([x, input_layer_2])    
    x = cbr(x, layer_n*4, kernel_size, 4, 1)
    for i in range(depth):
        x = resblock(x, layer_n*4, kernel_size, 1)
    
    ########### Decoder
    x = UpSampling1D(4)(x)
    x = Concatenate()([x, out_2])
    x = cbr(x, layer_n*3, kernel_size, 1, 1)

    x = UpSampling1D(4)(x)
    x = Concatenate()([x, out_1])
    x = cbr(x, layer_n*2, kernel_size, 1, 1)

    x = UpSampling1D(4)(x)
    x = Concatenate()([x, out_0])
    x = cbr(x, layer_n, kernel_size, 1, 1)    
        
    #classifier  x = Conv1D(5, kernel_size=kernel_size, strides=1, padding="same")(x)
    x = Conv1D(5, 1, padding="same")(x)
    out = Activation("softmax")(x)
    
    model = Model(input_layer, out)
    
    return model


def abnormal_normal_resnet(input_shape=(1, 4096, 4)):
    
    input_tensor = Input(shape=input_shape, dtype='float32')
    x1 = resnet_CNN_1(input_tensor,19,128)
    x1 = resnet_CNN_1(x1,9,256)
    x1 = resnet_CNN_1(x1,5,512)
    x1 = resnet_CNN_1(x1,3,512)
    x1 = resnet_CNN_2(x1)
    x1 = Flatten()(x1)
    x1 = Dropout(0.1)(x1)
    output_tensor = Dense(1, activation='sigmoid',kernel_regularizer=regularizers.l2(0.01))(x1)

    resnet50_abnormal_normal = Model(input_tensor, output_tensor)
    
    return resnet50_abnormal_normal

def multiclass_resnet(input_shape=(1, 4096, 4)):
    
    input_tensor1 = Input(shape=(1, 4096, 4), dtype='float32')
    x = resnet_CNN_1(input_tensor1,19,128)
    x = resnet_CNN_1(x,9,256)
    x = resnet_CNN_1(x,5,512)
    x = resnet_CNN_1(x,3,512)
    x = resnet_CNN_3(x)
    x = Flatten()(x)
    x = Dropout(0.1)(x)
    output_tensor1 = Dense(3, activation='softmax',kernel_regularizer=regularizers.l2(0.01))(x)  #softmax  kernel_regularizer=regularizers.l2(0.01)

    multiclass_resnetModel = Model(input_tensor1, output_tensor1)
    
    return multiclass_resnetModel

def signal_noise_butter(wav_data,fs=4000):
    butter_hp = signal.butter(4, 25, 'hp', fs=4000, output='sos')
    butter_lp = signal.butter(4, 400, 'lp', fs=4000, output='sos')
    filtered_hp = signal.sosfilt(butter_lp, wav_data)
    filtered = signal.sosfilt(butter_hp, filtered_hp)
    return filtered


def sipke_removal(wav_data,fs=4000):
    windowsize = np.round(fs/4)
    trailingsamples = (len(wav_data))%(windowsize)
    sampleframes = np.transpose(wav_data[0:int(len(wav_data)-trailingsamples)].reshape(int((len(wav_data)-trailingsamples)/windowsize),int(windowsize)))
    MAAs = np.max(np.abs(sampleframes),axis=0)
    
    cnt=1
    while ((MAAs>np.median(MAAs)*3).any()):
        if cnt>10000:
            break
        val=np.max(MAAs)
        window_num=np.argmax(MAAs)

        if(np.size(window_num)>1):
            window_num = window_num[0]

        val=np.max(np.abs(sampleframes[:,window_num]))
        spike_position=np.argmax(np.abs(sampleframes[:,window_num]))
        
        if(np.size(spike_position)>1):
            spike_position = spike_position[0]
            
        zero_crossings =np.hstack([np.abs(np.diff(np.sign(sampleframes[:,window_num])))>1, 0])
    
        #%Find the start of the spike, finding the last zero crossing before
        #%spike position. If that is empty, take the start of the window:
        spike_start = np.max(np.vstack([1, np.argwhere(zero_crossings[0:spike_position+1]==1)]))
        
        #%Find the end of the spike, finding the first zero crossing after
        #%spike position. If that is empty, take the end of the window:
        zero_crossings[0:spike_position+1] = 0
        spike_end = np.min(np.vstack([np.argwhere(zero_crossings==1),windowsize]))
        
        #%Set to Zero
        sampleframes[int(spike_start):int(spike_end),window_num] = 0.0001
    
        #%Recaclulate MAAs
        MAAs = np.max(np.abs(sampleframes),axis=0)
        # print(cnt)
        cnt=cnt+1
    # print(cnt)
    despiked_signal = np.transpose(sampleframes).flatten()

    #% Add the trailing samples back to the signal:
    despiked_signal2 = np.hstack([despiked_signal,wav_data[len(despiked_signal):len(wav_data)]])
    
    return despiked_signal2


def preprocess_butter_func(wav_4096):
    preprocess_butter=list()
    for i in range(wav_4096.shape[0]): #24100 17253
        butter=list()
        for j in range(4):
            tmp=wav_4096[i,:,j]
            tmp_butter=signal_noise_butter(tmp)
            butter.append(tmp_butter)
        np.asarray(butter)
        preprocess_butter.append(butter)

    
    # butter data
    preprocess_butter=np.asarray(preprocess_butter,dtype=float)
    preprocess_butter=np.transpose(preprocess_butter,[0,2,1])
    return preprocess_butter


def preprocessing_data(data_folder, model_folder):
    verbose=1
    if verbose >= 1:
        print('Finding data files...')
    
    
    # Find the patient data files.
    patient_files = find_patient_files(data_folder)
    num_patient_files = len(patient_files)
    
    if num_patient_files==0:
        raise Exception('No data was provided.')
    
    
    classes = ['Present', 'Unknown', 'Absent']
    num_classes = len(classes)
    
    classes2 = ['Abnormal', 'Normal']
    num_classes2 = len(classes2)
    
    # Extract the features and labels.
    if verbose >= 1:
        print('Extracting features and labels from the Challenge data...')
    
    features_wav,features_state,labels,labels2=get_wav_state_labels(num_patient_files,patient_files,data_folder,num_classes,classes,num_classes2,classes2,verbose=1) ######labels argument name change needed
    
    # 4096 segmentation
    if verbose >= 1:
        print('Segmenting data to 4096...')
    wav_4096,seg_4096,label_4096,label_4096_2=segmentation_4096(features_wav,features_state,labels,labels2)
    
    savez_compressed('outcomeTrain.npz', (wav_4096+1)/2, label_4096_2) # (wav_4096+1)/2
                  
    
    #preprocess
    if verbose >= 1:
        print('Preprocessing butterworth filtering...')
    
    # preprocess_butter=preprocess_butter_func(wav_4096)
    
    
    ## onehot to 1,2,3, label change
    label_4096_1=np.argmax(label_4096,axis=1)
    label_4096_1=label_4096_1.reshape(label_4096_1.shape[0],1)
    
    
    
    
    savez_compressed('multiclass.npz', (wav_4096+1)/2, label_4096_1) # (wav_4096+1)/2   label_4096  label_4096_1
    
    
    
def train_multiclass(model_folder):
    
    print('Training model: multiclass...')  
    print(gc.collect())
    K.clear_session()
    
    data_wav = load('multiclass.npz')
    preprocess_butter1, label_4096 = data_wav['arr_0'], data_wav['arr_1'] 
    
    resnet50_known_unknown = multiclass_resnet(input_shape=(1, 4096, 4))   
    opt = adam_v2.Adam(learning_rate=0.0001, beta_1=0.5) #0.00005
    resnet50_known_unknown.compile(loss='sparse_categorical_crossentropy', optimizer=opt, metrics=['sparse_categorical_accuracy']) #categorical_crossentropy  binary_crossentropy  sparse_categorical_crossentropy
        
    class_weight = {0: 9., 1: 5., 2: 1.}

    x_train1, y_train1=preprocess_butter1.reshape(preprocess_butter1.shape[0],1,4096,4), label_4096
    x_train1, _ , y_train1, _=train_test_split(x_train1, y_train1, test_size=0.1,random_state=42)
    
    # resnet50_known_unknown.fit(x_train1, y_train1, epochs=60, batch_size=128, validation_split=0.2) ##-> original
    resnet50_known_unknown.fit(x_train1, y_train1, epochs=50, batch_size=64,validation_split=0.2, class_weight=class_weight)  ## -> class weight 
    
    resnet50_known_unknown.save_weights(os.path.join(model_folder, 'resnet50_known_unknown.h5'))
    
    
def train_abnormal_normal(model_folder):

    print('Training model: Abnormal and Normal...') 

    K.clear_session()
    print(gc.collect())
    
    data = load('outcomeTrain.npz')
    wav_ab_norm, label_4096_2 = data['arr_0'], data['arr_1'] 
    
    outcome_model=abnormal_normal_resnet(input_shape=(1, 4096, 4))
    
    opt1 = adam_v2.Adam(learning_rate=0.001, beta_1=0.5)
    outcome_model.compile(loss='binary_crossentropy', optimizer=opt1, metrics=['accuracy'])    

    
    x_train1, y_train1=wav_ab_norm.reshape(wav_ab_norm.shape[0],1,4096,4), label_4096_2[:,0].reshape(label_4096_2.shape[0],1)  ###############
    x_train1, _ , y_train1, _=train_test_split(x_train1, y_train1, test_size=0.1,random_state=42)
    outcome_model.fit(x_train1, y_train1, epochs=50, batch_size=64, validation_split=0.2) 
    outcome_model.save_weights(os.path.join(model_folder, 'outcome_model.h5'))
    
    
def train_net(model_folder):
    
    print('Training model: Unet...')  

    K.clear_session()
    print(gc.collect())
    
    trainset, traintarget = load_real_samples('unetTrainset.npz')
    # train_input=trainset
    train_target=label_encoding(traintarget)    
    
    model_unet = Unet(input_shape=(None,1))

    n_epoch=10
    batch_size=32

    opt = adam_v2.Adam(learning_rate=0.005, beta_1=0.5) #loss_weights=[1,100]  categorical_crossentropy
    model_unet.compile(loss='binary_crossentropy',optimizer=opt,metrics=["accuracy"])

    model_unet.fit(trainset, train_target, steps_per_epoch = len(trainset) // batch_size,epochs=n_epoch,batch_size=32,verbose=1)
    model_unet.save(os.path.join(model_folder, 'u_net.h5'))



